#ifndef __MESSAGES_HPP
#define __MESSAGES_HPP

#include "yyybinbuff.hpp"
#include "tempmatrix.hpp"
#include "yyysmartptr.hpp"

class cell {
public:
  inline cell() : ascii(' '), colnum(0) {};
  uint8 ascii;
  uint8 colnum;
};

void appendtobinbuffer (const cell &a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer (cell &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);


typedef tempmatrix<cell> tempm_cell;
typedef yyysmartptr::smartptr<tempm_cell> sptr_tempm_cell;

void appendtobinbuffer (const tempm_cell &a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer (tempm_cell &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);


struct MSG_cc {
  tempm_cell::index_t x, y;
  cell cl;
};

void appendtobinbuffer (const MSG_cc &a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(MSG_cc &a, const yyybinbuff::binbuff &b,const yyybinbuff::binbuff::index pos);

#endif
